﻿
#define F_CPU	16000000UL

#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>


void UART_int(void)
{
	UCSR0A = 0;			// 비동기 모드
	UCSR0B = 0x98;		// RX,TX 동작허용, 문자길이 8비트,수신 인터럽트
	UCSR0C = 0x06;		// 비동기 모드 송신시 상승에지, 수신시 하강에지, 전송데이터 8비트
	UBRR0H = 0x00;		// 보레이트 설정 9600bps -->>UBRR = 8(U2X=0, 16MHz일때)
	UBRR0L = 0x67;
}
unsigned char rx0_char(void)
{
	while((UCSR0A&0x80) == 0X00);
	return UDR0;
}
void tx0_char(char ch)
{
	while((UCSR0A&0x20) == 0X00);
	UDR0 = ch;
}

ISR(SIG_UART0_RECV)
{
	unsigned char rdata;
	rdata = UDR0;
	
	/*
	if(rdata == 'a') 
		PORTG = 0xff;
	else 
		PORTG = 0x0;
	//*/
	
	if (rdata == '1')
	{
		PORTG = PORTG ^ 0x01;
	}
	else if (rdata == '2')
	{
		PORTG = PORTG ^ 0x02;
	}
	else if (rdata == '3')
	{
		PORTG = PORTG ^ 0x04;
	}
	else if (rdata == '4')
	{
		PORTG = PORTG ^ 0x08;
	}
	else if (rdata == 't')
	{
		PORTG = PORTG ^ 0xff;
	}
	else if (rdata == 'a')
	{
		PORTG = 0xff;
	}
	else
	{
		PORTG = 0x00;
	}
	
	
	
	tx0_char(rdata);
}

void uart_putChar(unsigned char commPort, unsigned char sendData)
{
	switch(commPort)
	{
	case 0:
		while(!( UCSR0A & 0x20 ));
		UDR0 = sendData;
		break;
	case 1:
		while(!( UCSR1A & 0x20 ));
		UDR0 = sendData;
		break;
	}
}

int sys_putchar(char c, FILE *file)
{
	tx0_char(c);
	if(c == '\n') tx0_char('\r');
}
FILE mystdout = FDEV_SETUP_STREAM(tx0_char, NULL, _FDEV_SETUP_WRITE);

int main(void)
{
    char ch;
    char buf[100];
    int xx;
    UART_int();
	DDRG = 0xff;

    stdout = &mystdout;
    printf("Hello Embedded HOlic ?\n");
    
    sei();
	
    while(1)
    {
		
    }
}